#define NOTEOFF 0x80
#define NOTEON 0x90

unsigned char track;            // Global for current track

void stepIn () {
  digitalWrite(3,LOW);
  digitalWrite(4,LOW);
  digitalWrite(4,HIGH);
  delay(2);
}

void stepOut () {
  digitalWrite(3,HIGH);
  digitalWrite(4,LOW);
  digitalWrite(4,HIGH);
  delay(2);
}

void seekTo (char tr) {
  char i;
  digitalWrite(8,HIGH);
  if (tr > track)
    for (i=0;i<(tr-track);i++)
      stepIn();
  else if (tr < track)
    for (i=0;i<(track-tr);i++)
      stepOut();
  track = tr;
  delay(20);
  digitalWrite(8,LOW);
}

void setup () {
  char i;
  digitalWrite(2,HIGH);
  digitalWrite(3,HIGH);
  digitalWrite(4,HIGH);
  digitalWrite(6,HIGH);
  digitalWrite(7,HIGH);
  digitalWrite(8,HIGH);
  pinMode(2,INPUT);
  pinMode(3,OUTPUT);
  pinMode(4,OUTPUT);
  pinMode(6,OUTPUT);
  pinMode(8,OUTPUT);
  Serial.begin(31250);
  Serial.flush();
  for(i=0;i<90;i++)
    stepOut();
  track = 0;
}

void loop () {
  unsigned char n, state, v, curr;
  for (;;) {
    while (!(Serial.available()));
    n = Serial.read();
    switch (n & 0x80) {
      case 0:
        switch (state) {
          case NOTEON:
            v = Serial.read();
            if (v) {
              seekTo (n);
              digitalWrite(8,LOW);
              curr = n;
            } else if (curr == n) {
              digitalWrite(8,HIGH);
            }
            break;
          case NOTEOFF:
            v = Serial.read();
            if (curr == n)
              digitalWrite(8,HIGH);
            break;
       }
      case 0x80:
        state = n & 0xF0;
        break;
    }
  }
}

