volatile char track;            // Global for current track

void stepIn () {
  digitalWrite(3,LOW);
  digitalWrite(4,LOW);
  digitalWrite(4,HIGH);
  delay(3);
}

void stepOut () {
  digitalWrite(3,HIGH);
  digitalWrite(4,LOW);
  digitalWrite(4,HIGH);
  delay(3);
}

void seekTo (char tr) {
  char i;
  digitalWrite(8,HIGH);
  if (tr > track)
    for (i=0;i<(tr-track);i++)
      stepIn();
  else if (tr < track)
    for (i=0;i<(track-tr);i++)
      stepOut();
  track = tr;
  delay(20);
  digitalWrite(8,LOW);
}

void setup () {
  char i;
  track = 0;
  digitalWrite(2,HIGH);
  digitalWrite(3,HIGH);
  digitalWrite(4,HIGH);
  digitalWrite(6,HIGH);
  digitalWrite(7,HIGH);
  digitalWrite(8,LOW);
  pinMode(2,INPUT);
  pinMode(3,OUTPUT);
  pinMode(4,OUTPUT);
  pinMode(5,INPUT);
  pinMode(6,OUTPUT);
  pinMode(7,INPUT);
  pinMode(8,OUTPUT);

  Serial.begin(9600);
  for(i=0;i<90;i++)
    stepOut();
}

void waitIndex () {
  while (digitalRead(2));
  while (!(digitalRead(2)));
}

void writeTrack () {
  waitIndex();
  digitalWrite(6,LOW);
  waitIndex();
  digitalWrite(6,HIGH);
}
void loop () {
  char input;
  while (!(Serial.available()));
  input = Serial.read();
  if (input == 'w')
    writeTrack();
  if (input == 'i')
    stepIn();
  if (input == 'o')
    stepOut();
}

